<script lang="ts">
  import { browser } from '$app/environment';
  import Canvas from '@svelte-common/components/Canvas.svelte';
  import Portal from '@svelte-common/components/Portal.svelte';
  import { scrollLock } from '@web-common/hooks/browser/scroll-lock.js';
  import { onMount } from 'svelte';
  import Container from './Container.svelte';
  import Close from './components/Close.svelte';
  import IslandNav from './components/IslandNav.svelte';
  import { enterWorld, triggerApp } from './world-store.js';

  let app: HTMLElement;
  let gsap: GSAP;

  $: $enterWorld ? activate() : deactivate();

  let scrollLockCb: CallbackWith<boolean>;

  let worldId: string;
  let worldSrc: string;

  // keep track of scroll value to allow cancel app activation
  let prevScrollPos: number;

  const scrollToApp = () => {
    prevScrollPos = document.documentElement.scrollTop;
    $triggerApp = true;
    app.scrollIntoView({ behavior: 'smooth' });

    const rect = app.getBoundingClientRect();
    if (rect.top === 0) {
      $enterWorld = true;
    }
  };

  const onScroll = () => {
    if (!$triggerApp) return;

    const rect = app.getBoundingClientRect();

    // Allow cancel of entering app if reverse the scroll
    const currentScrollPos = document.documentElement.scrollTop;
    if (currentScrollPos > prevScrollPos) {
      $enterWorld = false;
      $triggerApp = false;
    } else if (rect.top === 0) {
      $enterWorld = true;
    } else {
      prevScrollPos = currentScrollPos;
    }
  };

  const onClose = () => {
    $triggerApp = false;
    $enterWorld = false;
  };

  const activate = () => {
    if (!browser) return;
    scrollLockCb?.(true);
    enterTween();
  };

  const deactivate = () => {
    if (!browser) return;
    scrollLockCb?.(false);
    exitTween();
  };

  const enterTween = () =>
    gsap?.to(app, {
      width: '100vw',
      height: '100vh',
    });

  const exitTween = () =>
    gsap?.to(app, {
      width: '100%',
      height: window.innerHeight * 0.85,
    });

  onMount(async () => {
    gsap = (await import('gsap/all')).gsap;
  });

  onMount(() => {
    const { lock, cleanUp } = scrollLock();
    scrollLockCb = lock;

    document.addEventListener('scroll', onScroll);

    // custom-path for 3D
    window.islands = {
      world: {
        id: 'world',
        path: '/world',
      },
    };

    worldId = 'world';
    worldSrc = '/world/assets/index.js';

    return () => {
      document.removeEventListener('scroll', onScroll);
      cleanUp();
    };
  });

  const onResize = () => {
    $enterWorld ? enterTween() : exitTween();
  };
</script>

<svelte:window on:resize={onResize} />

<section
  bind:this={app}
  class="app-wrapper">
  <Container on:click={scrollToApp}>
    {#if worldSrc}
      <Canvas
        id={worldId}
        src={worldSrc} />
    {/if}
  </Container>
</section>

<Close
  class="close"
  on:close={onClose}
  play={$enterWorld} />

<Portal><IslandNav /></Portal>

<style>
  .app-wrapper {
    height: calc(100vh * 0.85);

    /* background-color: rgb(0 0 0 / 23.3%); */
  }

  @media (width >= 768px) {
    .app-wrapper {
      width: 100%;
      margin-top: calc(var(--header-height) * -1);
    }
  }
</style>
